"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.testSuiteFindOne = testSuiteFindOne;
const assert_1 = __importStar(require("assert"));
const mocha_1 = __importDefault(require("mocha"));
const errors_js_1 = require("../../errors.js");
function testSuiteFindOne(repositoryTestData) {
    const testSuite = new mocha_1.default.Suite('findOne');
    for (const key in repositoryTestData.entityData) {
        testSuite.addTest(new mocha_1.default.Test(`should find a specific existing model (${key})`, async function () {
            const model = (await repositoryTestData.repository.findOne({
                where: repositoryTestData.getFindOptionsWhere(repositoryTestData.entityData[key].model),
            }));
            (0, assert_1.default)(model);
            (0, assert_1.default)(repositoryTestData.compareModels(model, repositoryTestData.entityData[key].model, false));
        }));
    }
    testSuite.addTest(new mocha_1.default.Test('should return null when the model does not exist', async function () {
        const model = await repositoryTestData.repository.findOne({
            where: repositoryTestData.getFindOptionsWhere(),
        });
        (0, assert_1.default)(model === null);
    }));
    testSuite.addTest(new mocha_1.default.Test('should throw an UninitializedRepositoryError if the repository has not been initialized', async function () {
        const unitializedRepository = new repositoryTestData.RepositoryClass();
        try {
            await unitializedRepository.findOne({});
            (0, assert_1.fail)();
        }
        catch (error) {
            (0, assert_1.default)(error instanceof errors_js_1.UninitializedRepositoryError);
        }
    }));
    return testSuite;
}
//# sourceMappingURL=findOne.spec.js.map