import { logger } from "./logging/index.js";
export function die(reason) {
    logger.log('error', reason);
    process.exit(1);
}
export function removeNullOrUndefined(obj) {
    if (Array.isArray(obj)) {
        return obj.map(removeNullOrUndefined);
    }
    if (typeof obj === 'object') {
        const newObj = {};
        for (const key in obj) {
            if (obj[key] !== null && obj[key] !== undefined) {
                newObj[key] = removeNullOrUndefined(obj[key]);
            }
        }
        return newObj;
    }
    return obj;
}
//# sourceMappingURL=utils.js.map